#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define X_MAX 10.0    /* κ */
#define X_MIN -10.0   /* κǾ */
#define X_RANGE (abs(X_MAX)+abs(X_MIN))


void usage();
double f(double x);
double df(double x);


void usage(){
  fprintf(stderr," Usage : prompt> ./a.out random-seed\n");
  exit(0);
}

/* ؿ f(x)
 *    Ϥ줿 x Ф y=f(x) ͤᡤ֤
 */
double f(double x) {
  double y;

  /** (1) **/
  y = -x*sin(x);
  return( y );
}

/* f(x)/dx
 *    y=f(x) ʬͤᡤ֤
 */
double df(double a) {
  double y_dx;

  /** (2) **/
  y_dx = -sin(a) - a*cos(a);
  return( y_dx );
}


int main(int argc, char **argv) {
  double x;
  int    i;
  double alpha = 0.1;
  /** alpha: ؽ졼
   *  ʲϰǤդꤷȼõΰưѻ补
   *  ʥݥȡalpha ˤȡŪޤưŪ˷ꤷ
   *ȤǳؽΨ˺ϤǤ뤫
   */
  int term_cond = 100; /* λʷ֤ */

  int seed;
  if( argc != 2 ){
    usage();
  }else{
    seed = atoi(argv[1]);
    srand(seed);
    rand();
  }

  /* step1. õν֤ */
  x = X_MIN + X_RANGE * (double)rand()/RAND_MAX;
  printf("trial 0 x %f f(x) %f\n", x,f(x));

  for (i = 1; i < term_cond; i++) {
    /* step2. õذư */

    /** (3) **/
    x = x - alpha*df(x);
    /* λ2 */
    if( (x <= X_MIN) || (x >= X_MAX) ){
      printf("trial %d x_rearched_to %f f(x) %f\n",i,x,f(x));
      break;
    }
    printf("trial %d x %f f(x) %f\n",i,x,f(x));
  }
  return 0;
}
