/*** TCP Server for inetd ***/

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/errno.h>
#include <string.h>
#include <ctype.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#define PORT 5524
#define	DATAFILE	"/Users/j05002/jikken2/tcp-ip/data/data.txt"
#define	DELIMITS	" \t\n\r"

char	datavalue[256];


int	GetLineFromPeer(int p,char *line)
{
int	i;

for(i = 0 ; ; )
	{
	if(1 != read(p ,line + i,1))
		continue;
	else
		{
		i++;
		*(line + i) = (char)0;
		}

	if(((char)('\n')) == (*(line + i - 1)))
		return i;
	}
}

char	*GetKeywordData(char *key)
{
FILE	*fp;
char	buff[256];

if((FILE *)NULL == (fp = fopen(DATAFILE,"r")))
	return (char *)NULL;

for(;;)
	{
	char	*p;
	char	*pp;

	fgets(buff,256,fp);

	if(feof(fp))
		break;

	if(ferror(fp))
		break;

	if((char *)NULL == (p = strtok(buff,DELIMITS)))
		continue;

	if((char *)NULL == (pp = strtok((char *)NULL,DELIMITS)))
		continue;

	if(0 == strcmp(p,key))
		{
		fclose(fp);
		strcpy(datavalue,pp);
		return datavalue;
		}
	}

fclose(fp);
return (char *)" ";
}


int	main()
{
char	RecvBuff[256];
   int sockfd;
   int wait_socket;
   int writer_len;
   struct sockaddr_in r_addr; 
   struct sockaddr_in w_addr;
   
   if ((sockfd = socket(PF_INET, SOCK_STREAM, 0)) < 0) { //IP\Pbg𐶐
   perror("socket");
   exit(1);
   }
   
   
   
   bzero((char *) &r_addr, sizeof(r_addr)); 
   r_addr.sin_family = PF_INET;
   r_addr.sin_addr.s_addr = htonl(INADDR_ANY);
   r_addr.sin_port = htons(PORT);
   
   
   if (bind(sockfd, (struct sockaddr *)&r_addr, sizeof(r_addr)) < 0) {
   perror("bind");
   exit(1);
   }
   
   
   if (listen(sockfd, 5) < 0) {
   perror("listen");
   close(sockfd);
   exit(1);
   }
   
   if ((wait_socket = accept(sockfd,(struct sockaddr *)&w_addr, &writer_len)) < 0) {
   perror("accept");
   exit(1);
   }

for(;;)
	{
	char	*p;
	char	SendBuff[256];
	char	*pp;

	(void)GetLineFromPeer(wait_socket,RecvBuff);	/* Get 1 line from peer */

	if(((char)('=')) == *(RecvBuff))	/* If End Mark */
	{
	exit(0);
	}

	if((char *)NULL != (p = strchr(RecvBuff,'=')))
		{
		*p = (char)0;

		if((char *)NULL == (pp = GetKeywordData(RecvBuff))){
		sprintf(SendBuff,"%s=\n",RecvBuff);
		}
		else{
		sprintf(SendBuff,"%s=%s\n",RecvBuff,pp);
		(void)write(wait_socket,SendBuff,strlen(SendBuff));
		}
		}
	}
}